/*
* Generated with LDDK Version 0.7-beta 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Blockdev_P.h>



int Blockdev_ioctl(struct inode* inode,struct file* file , unsigned int cmd, unsigned long arg )
{
  void *argp;
  int retval;
  
  DBGin("Blockdev_ioctl");
  DBGprint(DBG_DATA,("cmd=%d",cmd));
  Blockdev_errno = 0;
  
  switch(cmd){

  
  
  #line 113 "Blockdev.ddl"

                  case BLKGETSIZE:
		       printk("Blockdev: BLKGETSIZE called\n");
                       /* Return the device size, expressed in sectors */
                       if (!arg) return -EINVAL; /* NULL pointer: not valid */
                       /*
                          err=verify_area(VERIFY_WRITE, (long *) arg, sizeof(long));
                          if (err) return err;
                          
                          put_user ( 1024* sbull_sizes[MINOR(inode->i_rdev)]
                          / sbull_hardsects[MINOR(inode->i_rdev)],
                          (long *) arg); 
                       */
                       return 0;

                  case BLKFLSBUF: /* flush */
		       printk("Blockdev: BLKFLSBUF called\n");
                       if (!suser()) return -EACCES; /* only root */
                       fsync_dev(inode->i_rdev);
                       invalidate_buffers(inode->i_rdev);
                       return 0;

                  case BLKRAGET: /* return the readahead value */
		       printk("Blockdev: BLKRAGET called\n");
                       if (!arg)  return -EINVAL;
                       /*
                       err = verify_area(VERIFY_WRITE, (long *) arg, sizeof(long));
                       if (err) return err;
                       put_user(read_ahead[MAJOR(inode->i_rdev)],(long *) arg);
                       */
                       return 0;

                  case BLKRASET: /* set the readahead value */
		       printk("Blockdev: BLKRASET called\n");
                       if (!suser()) return -EACCES;
                       if (arg > 0xff) return -EINVAL; /* limit it */
                       read_ahead[MAJOR(inode->i_rdev)] = arg;
                       return 0;

      		  case BLKRRPART: /* re-read partition table: can't do it */
		       printk("Blockdev: BLKRRPART called\n");
        	       return -EINVAL;

                  RO_IOCTLS(inode->i_rdev, arg); /* the default RO operations */

		  
                  case HDIO_GETGEO:
                  /*
                   * get geometry: we have to fake one...  trim the size to a
                   * multiple of 64 (32k): tell we have 16 sectors, 4 heads,
                   * whatever cylinders. Tell also that data starts at sector. 4.
                   */
                  { 
                      struct hd_geometry *geo = (struct hd_geometry *)arg;  
		      int err,size;

                      printk("Blockdev: HDIO_GETGEO called\n");
                      if (geo==NULL) return -EINVAL;
                      err = verify_area(VERIFY_WRITE, geo, sizeof(*geo));
                      if (err) return err;
                      size = Blockdev_size * 1024 / Blockdev_hardsect;
                      size &= ~0x3f; /* multiple of 64 */
                      put_user(size >> 6, &geo->cylinders);
                      put_user(        4, &geo->heads);
                      put_user(       16, &geo->sectors);
                      put_user(        4, &geo->start);
                      return 0;
                  }




	     
  default:
    DBGout();	
    return -EINVAL;
  }
  
  

  DBGout();
  return 1;

}
