#include <rmgr_P.h>


rmgr_AssignFunc( struct inode *inode,char *to, int tolen, char *from, int frlen )
{

#line 215 "rmgr.ddl" 
		char *buf1,*buf2;
                RCS_entry *np1,*np2;

	  	DBGin("AssignFunc");
	        if( (buf1 = (char *) 
                     rmgr_GetFromFS((void *) to,tolen)) == NULL ){
                     DBGout();return -EIO;
                }
	        if( (buf2 = (char *) 
                     rmgr_GetFromFS((void *) from,frlen)) == NULL ){
                     kfree(buf1);
                     DBGout();return -EIO;
                }
	        DBGprint(DBG_DATA,("to=%s from=%s",buf1,buf2));
                if((np2 = RCS_lookup(buf2)) == NULL ){
		    kfree(buf1);kfree(buf2);
		    DBGout();return -ENOPERM; 
		}		
                if((np1 = RCS_lookup(buf1)) == NULL ){
		    kfree(buf1);kfree(buf2);
		    DBGout();return -ENOPERM; 
		}		
		if( (np1->type != RCS_FPTR) || (np2->type != RCS_FPTR)){
		    kfree(buf1);kfree(buf2);
		    DBGout();return -ENOTYPE; 
		}
		np1->uval.fptr = np2->uval.fptr;
                if( np1->callback != NULL ){
	          DBGprint(DBG_DATA,("calling callback"));
	          (*np1->callback)(RCS_CHANGE_EVENT,np1);
                }
	        DBGprint(DBG_DATA,("%s changed to %lx ",buf1,np1->uval.fptr));
                kfree(buf1);kfree(buf2);
		DBGout();
          
}
