#include <rmgr_P.h>


rmgr_SetInt( struct inode *inode,char *name, int len, int aint )
{

#line 256 "rmgr.ddl"
		  char *buf;
		  RCS_entry entry;
		  RCS_entry *np;
		  extern int umask;

                  DBGin("SetInt");
		  if( (buf = (char *) rmgr_GetFromFS((void *) name,len)) == NULL ){
                        DBGout();return -EIO;
                  }
	          DBGprint(DBG_DATA,("name=%s int=%d",buf,aint));

		  if( (np = RCS_lookup(buf)) != NULL ){ 
		     if( np->type != RCS_INT && np->type != RCS_IPTR ){
			DBGprint(DBG_DATA,("type conflict %d",np->type));
			Error(-ENOTYPE);kfree(buf);
			DBGout(); return -1;
		     }
                     if( ! RCS_CheckPerm(np,RCS_PERM_WRITE)){
			DBGprint(DBG_DATA,("write permission denied"));
			DBGout(); return -1;
		     }
		     RCS_lock(np);
                     if( np->type == RCS_INT )
   		           np->uval.ival = aint;
                     else
			   *np->uval.iptr = aint;				
		     RCS_install(buf,np);
		     RCS_unlock(np);
                  } else {
		     entry.type = RCS_INT;
		     entry.uval.ival = aint;
                     entry.mflags = umask;
		     RCS_install(buf,&entry);
  		     DBGprint(DBG_DATA,("wrote %s as %d",buf,entry.uval.ival));
                  }
		  kfree(buf);
		  DBGout();return 1;
	  
}
