#include <rmgr_P.h>


rmgr_SetString( struct inode *inode,char *name, int len,char *sbuf, int slen )
{

#line 129 "rmgr.ddl"
		  char *buf;
	          char *buf2;
		  RCS_entry entry;
		  RCS_entry *np;
                  DBGin("SetString");
		  if( (buf = (char *) rmgr_GetFromFS((void *) name,len)) == NULL ){
                        DBGout();return -EIO;
                  }
		  if( (buf2 = (char *) rmgr_GetFromFS((void *) sbuf,slen)) == NULL ){
                        DBGout();return -EIO;
                  }
	          DBGprint(DBG_DATA,("name=%s string=%s",buf,buf2));
		  if( (np = RCS_lookup(buf)) != NULL ){ 
		     if( np->type != RCS_STRING ){
			DBGprint(DBG_DATA,("type conflict"));
			Error(-ENOTYPE);kfree(buf);kfree(buf2);
			DBGout(); return -1;
		     }
                     if( ! RCS_CheckPerm(np,RCS_PERM_WRITE)){
			DBGprint(DBG_DATA,("write permission denied"));
			Error(-ENOPERM);kfree(buf);kfree(buf2);
			DBGout(); return -1;
		     }
                     RCS_lock(np);
		     entry.type = RCS_STRING;
		     entry.uval.sval = buf2;
                     entry.mflags = np->mflags;
		     RCS_install(buf,&entry);
		     RCS_unlock(np);
                  } else {
		     entry.type = RCS_STRING;
		     entry.uval.sval = buf2;
                     entry.mflags = O_RD | O_WR;
		     RCS_install(buf,&entry);
   		     DBGprint(DBG_DATA,("wrote %s as %s",buf,entry.uval.sval));
                  }
		  kfree(buf);
                  kfree(buf2);
		  DBGout(); return 1;
	  
}
