/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <rmgr_P.h>



int rmgr_ioctl(struct inode* inode,struct file* file , unsigned int cmd, unsigned long arg )
{
  void *argp;
  int retval;
  
  DBGin("rmgr_ioctl");
  DBGprint(DBG_DATA,("cmd=%d",cmd));
  rmgr_errno = 0;
  
  switch(cmd){

        case GETTYPE:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(GetType_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(GetType_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(GetType_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (GetType_par_t *) arg, sizeof(GetType_par_t));
              ((GetType_par_t *) argp)->retval = rmgr_GetType( inode, ((GetType_par_t *) argp)->name, 
				 ((GetType_par_t *) argp)->len );
              ((GetType_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (GetType_par_t *) arg, (void *) argp, sizeof(GetType_par_t));
              kfree(argp);
              break;
      case CHMOD:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Chmod_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Chmod_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Chmod_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (Chmod_par_t *) arg, sizeof(Chmod_par_t));
              ((Chmod_par_t *) argp)->retval = rmgr_Chmod( inode, ((Chmod_par_t *) argp)->name, 
				 ((Chmod_par_t *) argp)->len, 
				 ((Chmod_par_t *) argp)->mode );
              ((Chmod_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (Chmod_par_t *) arg, (void *) argp, sizeof(Chmod_par_t));
              kfree(argp);
              break;
      case SETSTRING:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(SetString_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(SetString_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(SetString_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (SetString_par_t *) arg, sizeof(SetString_par_t));
              ((SetString_par_t *) argp)->retval = rmgr_SetString( inode, ((SetString_par_t *) argp)->name, 
				 ((SetString_par_t *) argp)->len, 
				 ((SetString_par_t *) argp)->sbuf, 
				 ((SetString_par_t *) argp)->slen );
              ((SetString_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (SetString_par_t *) arg, (void *) argp, sizeof(SetString_par_t));
              kfree(argp);
              break;
      case GETSTRING:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(GetString_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(GetString_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(GetString_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (GetString_par_t *) arg, sizeof(GetString_par_t));
              ((GetString_par_t *) argp)->retval = rmgr_GetString( inode, ((GetString_par_t *) argp)->name, 
				 ((GetString_par_t *) argp)->len, 
				 ((GetString_par_t *) argp)->sbuf );
              ((GetString_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (GetString_par_t *) arg, (void *) argp, sizeof(GetString_par_t));
              kfree(argp);
              break;
      case ASSIGNFUNC:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(AssignFunc_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(AssignFunc_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(AssignFunc_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (AssignFunc_par_t *) arg, sizeof(AssignFunc_par_t));
              ((AssignFunc_par_t *) argp)->retval = rmgr_AssignFunc( inode, ((AssignFunc_par_t *) argp)->to, 
				 ((AssignFunc_par_t *) argp)->tolen, 
				 ((AssignFunc_par_t *) argp)->from, 
				 ((AssignFunc_par_t *) argp)->frlen );
              ((AssignFunc_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (AssignFunc_par_t *) arg, (void *) argp, sizeof(AssignFunc_par_t));
              kfree(argp);
              break;
      case SETINT:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(SetInt_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(SetInt_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(SetInt_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (SetInt_par_t *) arg, sizeof(SetInt_par_t));
              ((SetInt_par_t *) argp)->retval = rmgr_SetInt( inode, ((SetInt_par_t *) argp)->name, 
				 ((SetInt_par_t *) argp)->len, 
				 ((SetInt_par_t *) argp)->aint );
              ((SetInt_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (SetInt_par_t *) arg, (void *) argp, sizeof(SetInt_par_t));
              kfree(argp);
              break;
      case GETINT:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(GetInt_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(GetInt_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(GetInt_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (GetInt_par_t *) arg, sizeof(GetInt_par_t));
              ((GetInt_par_t *) argp)->retval = rmgr_GetInt( inode, ((GetInt_par_t *) argp)->name, 
				 ((GetInt_par_t *) argp)->len );
              ((GetInt_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (GetInt_par_t *) arg, (void *) argp, sizeof(GetInt_par_t));
              kfree(argp);
              break;
      case DELETE:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Delete_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Delete_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Delete_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (Delete_par_t *) arg, sizeof(Delete_par_t));
              ((Delete_par_t *) argp)->retval = rmgr_Delete( inode, ((Delete_par_t *) argp)->name, 
				 ((Delete_par_t *) argp)->len );
              ((Delete_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (Delete_par_t *) arg, (void *) argp, sizeof(Delete_par_t));
              kfree(argp);
              break;
      case INFO:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Info_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Info_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Info_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (Info_par_t *) arg, sizeof(Info_par_t));
              ((Info_par_t *) argp)->retval = rmgr_Info( inode  );
              ((Info_par_t *) argp)->error = rmgr_errno;
              memcpy_toio( (Info_par_t *) arg, (void *) argp, sizeof(Info_par_t));
              kfree(argp);
              break;

  
  
  default:
    DBGout();	
    return -EINVAL;
  }
  
  

  DBGout();
  return 1;

}
