#
#   
#   This Makefile has been generated with LDDK Version %<version>
#   (c) 1996 by Claus Schroeter (clausi@chemie.fu-berlin.de)
#
#
#
#   Creation Date: %<date>

.SILENT:

MAKE = make -C

INCDIR  = 
SUBDIRS = driver lib

TKPARSE = /usr/local/lib/lddk/tkparse
HEADER  = /usr/local/lib/lddk/header.tk
TAIL    = /usr/local/lib/lddk/tail.tk


BOLD		= "\033[1m"
NBOLD		= "\033[0m"

ECHO		= /bin/echo

COMPILE	= $(ECHO) "--- Compiling "$(BOLD)$<$(NBOLD)"..." ; gcc
DEPEND	= $(ECHO) "--- Checking dependencies..." ; gcc
RLINK	= $(ECHO) "--- Linking (relocatable) "$(BOLD)$@$(NBOLD)"..." ; ld -r
LINK	= $(ECHO) "--- Linking "$(BOLD)$@$(NBOLD)"..." ; gcc
INSTALL	= $(ROOT)/util/Install.sh
RM	= $(ROOT)/util/Remove.sh
YACC	= $(ECHO) --- Running bison on $(BOLD)$<$(NBOLD)...; bison -d -y
LEX	= $(ECHO) --- Running flex on $(BOLD)$<$(NBOLD)...; flex 

CC	= $(COMPILE) $(CFLAGS)

all: %<config.make> subdirs

subdirs:  
	set -e;for i in $(INCDIR) $(SUBDIRS); do \
	$(ECHO) "|||" Making target $(BOLD)all$(NBOLD) in subdirectory $(BOLD)$$i$(NBOLD)... ; \
	$(MAKE) $$i ; \
	$(ECHO) "|||" Leaving subdirectory $(BOLD)$$i$(NBOLD)...; \
	done

clean:
	set -e;for i in $(SUBDIRS); do \
	$(ECHO) "|||" Making target $(BOLD)$@$(NBOLD) in subdirectory $(BOLD)$$i$(NBOLD)... ; \
	$(MAKE) $$i clean; \
	$(ECHO) "|||" Leaving subdirectory $(BOLD)$$i$(NBOLD)...; \
	done
	-rm .config .xconfig

load:
	set -e;cd driver; make load

unload:
	set -e;cd driver; make unload

config.tk: ./config.in
	$(ECHO) "|||" Generating Configure script for X11 and Tcl/Tk; \
	if [ -f /usr/local/bin/wish ];	then \
		echo '#!'"/usr/local/bin/wish -f" > config.tk; \
	else \
		echo '#!'"/usr/bin/wish -f" > config.tk; \
	fi
	cat ${HEADER} >> ./config.tk
	${TKPARSE} < ./config.in >> ./config.tk
	touch defconfig
	touch include/autoconf.h
	echo "set defaults \"defconfig\"" >> config.tk
	cat ${TAIL} >> config.tk
	chmod 755 config.tk

.config: config.in
	$(ECHO) "|||" Configure Driver Options; \
	sh Configure

.xconfig: config.tk
	$(ECHO) "|||" Executing Configure script; \
	./config.tk
	touch xconfig

xconfig: config.tk 
	$(ECHO) "|||" Executing Configure script; \
	./config.tk

config: config.in 
	$(ECHO) "|||" Executing Configure script; \
	sh Configure