#
#   
#   This Makefile has been generated with LDDK Version %<version>
#   (c) 1996 by Claus Schroeter (clausi@chemie.fu-berlin.de)
#
#
#
#   Creation Date: %<date>

.SILENT:

DEFS = -DDEBUG=1 -DDEFAULT_DEBUG -D%<driver.name>_MAJOR=%<driver.major> \
	%<make.add-defs> 

OPTIONS = %<driver.make-options>
INCLUDES = -I. -I../include %<driver.make-includes>

OBJS = %<driver.make-objects> %<driver.custom-objects>
SRCS = %<driver.make-sources> %<driver.custom-sources>

CFLAGS = -D__KERNEL__ -DLINUX -O6 -m486 $(DEFS) $(OPTIONS) $(INCLUDES)


BOLD		= "\033[1m"
NBOLD		= "\033[0m"

ECHO		= /bin/echo

COMPILE	= $(ECHO) "--- Compiling "$(BOLD)$<$(NBOLD)"..." ; gcc
DEPEND	= $(ECHO) "--- Checking dependencies..." ; $(CPP)
RLINK	= $(ECHO) "--- Linking (relocatable) "$(BOLD)$@$(NBOLD)"..." ; ld -r
LINK	= $(ECHO) "--- Linking "$(BOLD)$@$(NBOLD)"..." ; gcc
INSTALL	= $(ROOT)/util/Install.sh
RM	= $(ROOT)/util/Remove.sh
YACC	= $(ECHO) --- Running bison on $(BOLD)$<$(NBOLD)...; bison -d -y
LEX	= $(ECHO) --- Running flex on $(BOLD)$<$(NBOLD)...; flex 

CC	= $(COMPILE) $(CFLAGS)


all:	%<driver.name>.o

%<driver.name>.o: $(OBJS)
	$(RLINK) -o %<driver.name>.o $(OBJS)


load:
	$(ECHO) "|||" Loading Driver Module to Kernel
	/sbin/insmod %<driver.name>.o 

unload:
	$(ECHO) "|||" Removing Driver Module from Kernel
	-/sbin/rmmod %<driver.name>

clean:
	-rm *.o .depend

depend .depend: $(SRCS)
	$(DEPEND) $(CFLAGS) -M $(SRCS)  >./.depend

include .depend



